""""

-----------
**Context**
-----------

The goal here is to deliver short-term forecasts on a 14 weeks horizon
and send it to the IBP environment.

Forecast granularity : predict volume per ``SKU / Warehouse / Day``

Additional feature : Promotional effects (uplifts) must be calculated for each forecast.
Those represent the percentage of volume that was generated by promotional effects.

NB : forecast is made on a weekly and daily basis, but must be disaggregated
to the daily level before being sent to IBP (98 days total).

--------------
**Data model**
--------------

.. figure:: ./../_static/data_model_spain_dairy.svg
  :width: 800
  :align: center

----------------
**Data Sources**
----------------

* Orders
* Promo
* Customers Hierarchy
* Products Hierarchy
* Warehouse Calendar
* IBP Master Data
* PLC Forecast Dates and Product Assignments
* Holidays (API)

--------------------------------------
**Data Preparation Pipelines**
--------------------------------------

**Core preparation steps**
==========================

1. Orders
---------

* Gather data
* Drop null orders
* Apply PLC Rules (more details on dedicated part)
    * SKU Replacements
    * Renovations
    * Delistings
* Update orders primaries
    * For each ``(product / customer)``, get the last primary warehouse
      that sent the product to the customer
    * Replace all location codes by this last primary warehouse code
      for each ``(product / customer)``
* Aggregate
    * Sum quantities per ``(product / warehouse / day)`` groups
* Resample
    * Expand dataset towards the future (to fulfill the 14 week horizon)
    * Create rows for all missing dates for each ``(product / warehouse)``


2. Products
-----------

* Gather data
* Filter out ``flavour_cod, mat_active_flag`` and active columns
* Drop duplications
* Create a new ``mat_volume`` column with formula:
    * ``mat_volume = (mat_length * mat_width * mat_height) / 1000``
* Multiply column ``mat_weight`` by ``1000``
* Merge with orders (result = panel data)

3. Service Level
----------------
* Column added to panel data with formula:
    * ``service_level = adjusted_units - assigned_units``

4. Holidays
-----------
* Create a new column "region" from a warehouse -> region mapping
* Gather holiday data fetched with API
* Create columns:
    * ``holiday_day_of_week`` (on which day of the week is the holiday, number between 0 and 6)
    * ``holidays_region_count`` (how many regions are in holidays at the same time)
* Update columns:
    * ``closed_holidays`` (1 if all the regions are in holidays at the same time, 0 if not)
    * ``partly_closed_holidays``
      (1 if more than 1/4 of the regions are in holiday at the same time, 0 if not)
* Merge with panel data

5. Warehouse Calendar
---------------------
* Gather warehouse calendar data
* Remove orders on warehouse closures
* Merge with Panel data

6. Cannibalization
------------------
Cannibalization represents how the products of the same family
or brand affect the sales of their relatives.

* For each of the cannib_columns
    * ``product_type_cod, mat_subfamily_cod, mat_prodbrand_cod, mat_umbrella_cod``
* And for each quantity_columns
    * assigned_units, assigned_units
* We sum each quantity_columns for each group like :
    * ``(date, warehouse, cannib_column).sum(quantity_column)``
* To finish, we create ``cannib_column = cannib_column - quantity_column``

7. Promotions
-------------
* More details in the promo pipeline section
* From promo pipeline gather:
    * core promo dataprep
    * retailers dataprep
    * uplifts dataprep
* Merge with orders

8. Innovation Split
-------------------
* Gather IBP Master Data
* Filter out inactive SKUs
* Read the IBP Master Data column : "Innovation Status".
  Products with status ``GPSv are innovations,
  products with status ``CORE_ST`` or ``CORE_LT`` are core.
* Return two files (the core data and the inno data)

**Promotion preparation pipeline**
==================================

1. Orders
---------

* Gather data
* Drop null orders
* Update orders primaries
* Apply PLC Rules (more details on dedicated part)
    * SKU Replacements
    * Renovations
    * Delistings
* Apply DL/CRP code updates
    * Replace all location codes that are secondary or tertiary warehouses
      by the principal warehouse that they are associated with
* Aggregate
    * Sum quantities per ``(product / customer / warehouse / day)`` groups

2. Promotions
-------------
* Gather data
* Apply PLC Rules (more details on dedicated part)
    * SKU Replacements
* Merge the warehouse column from the orders data
* Remove all promotions that are not mapped to any principal warehouse

3. Customers
------------
* Gather data
* Merge franchise_code column for each customer on promo data



*First preparations on promotions*
==================================

.. figure:: ./../_static/promotion_first_dataprep_spain_dairy.png
  :width: 800
  :align: center


For each promotion, we have a line with a start and end date associated
with a couple (warehouse,customer,sku).
The following steps are first performed on this promo file in order to make it usable:

1. Expand
---------

Target one line per day (ex: if the promotion lasts 10 days, we will have 10 lines),
at level warehouse,customer,sku, date
* Management of the days with several promotions at the same time
We keep only the one with the most recent start date
(ex: if the first promotion starts on 10/06/18 and ends on 20/06/18
while the second one starts on 18/06/18 and ends on 24/06/18,
we assign the days of 18,19 and 20/06 to the second promotion).
Another possibility would be to favor certain mechanics instead of taking the most recent promotion
(Our choice was based on the recency by empirical analysis of the performances).
(at level warehouse,customer,sku, date)

2. Sunday withdrawal
--------------------

Remove all lines related to sundays, as they are no orders on sundays.

3. Offset the start date
------------------------

Today, this delay is 3 days for all customers, it is being adapted for each retailer.
This delay aims to take into account the effect that retailers often buy ahead of schedule -
probably an arrangement with Danone.
Separation between the beginning of the promotion (first 7 days) and the rest
(from the 8th day until the end of the promotion).
Experiments are in progress for a fairer division of these promotions into blocks
(last XP in progress: first 3 days, next 3, the rest).
Once these steps are completed, the promo file is ready to be used.

4. Merge with orders
--------------------

Merge with the orders data.
The merge creates lines without promotions but with quantities sold.
Those lines are kept to calculate the promotion uplifts.


*Promotions : Feature Engineering*
==================================

Several features have been built

1. Rolling means
----------------

The objective being for a given day, taking into account the customers in promotion and
the type of promotion, to retroactively calculate the rolling average of the orders carried out,
and this at different horizons (last 7 occurrences, last 14, etc.). Several steps for this:
Recovery of the prepared promo table
Left merge orders with the promo table to get the purchase volume for each day of promotion
Construction of the rolling means as explained above (several windows as shown)
For each day we recover the value of the Saturday of the previous week
We then aggregate to the warehouse mesh, day, sku

2. Top retailers
----------------

Number of top retailers (the top being to be qualified in the last quarter) to be in promotion
as well as the absolute number of retailers in promotion.

List of retailers in promotion (feature not yet developed but to be tested):
Encode the list of retailers in promotion to integrate specificities related to certain brands.

3. Uplifts
----------

Represent the spikes in volumes related to promotional effects.


In Spain, these features are calculated every week during weekends,
for computational resources needs.
They are calculated for the time horizon W-0 to W-8.
The promotion features are not re-calculated during the week.
If the promotion data changes during a week, it will be taken into account on the next weekend.


**Building Blocks**
===================

Building blocks are calculated from the promo table.

The promo table contains the columns :

``product, warehouse, franchise, volume, promotion_type)``

Are contained orders with promotions
(promotion_type != 0, the product was ordered while being in promo for a franchise)
and without promotions (promotion_type = 0)

There are three promotion types : ``CRM``, ``MC`` (Multi buy), and ``TPR`` (coupons).

Here are the steps of the table creation, which is made
for each ``(product, warehouse, franchise)`` :

1. We take a period of ~ one year from the dataset, starting from the current date, backward
2. We compute, for each warehouse, the market share of the franchise.
   The market share is the ratio : volume sold by franchise apart from promotions
   divided by volume sold by all franchises apart from promotions
3. We clean the volumes if there are periods where promo and no_promo flags are overlapping
4. We calculate the mean of volume quantities sold while in ``CRM, MC, TPR, no promo``
5. We compute the uplifts : ``uplift = (promo_annual_mean / no_promo_annual_mean) - 1``,
   for each of the 3 types.

Then, we have an uplift on base 100, and which is clipped to 0 if the value is below 0.
6. We multiply the uplifts by the market shares
7. We regularize the uplifts to capture the other franchises uplifts effects

Promotions are set up two months in advance, so we have the information of which franchise
will have promotion for a product in the future, and which type of promotion it will be.

Hence, after generation our forecasts, we can apply the uplift coefficients of the building block
table to our forecasts, which will tell us how much the promotion effect counted in term of volume.
More information on the IBP export paragraph.

**Product Life cycles**
=======================

Product have different life cycles, and need to be forecasted accordingly.

The IBP Master Data is the file taken to differentiate
the SKUs that are inactive (not to be forecasted),
that have an innovation status (the ``GPS`` status, to be forecasted with the innovation pipeline)
and those that have regular status ``CORE_ST`` or ``CORE_LT`` statuses.

.. figure:: ./../_static/ibp_master_data_workflow_spain_dairy.png
  :width: 800
  :align: center


When a SKU has an innovation status, we check the PLC file in order to see
if the SKU has a particular Active flag.
The SKU will be forecasted by the inno pipeline only if its PLC Active status is "X".

.. figure:: ./../_static/plc_workflow_1_spain_dairy.png
  :width: 800
  :align: center


Some other SKUs are being delisted, or listed as "renovations".

The delisted SKU stop being forecasted from a date
that is inscribed in the PLC data (the phaseout dates).
The renovation start being forecasted from a date
that is inscribed in the PLC data (the phase-in dates).

We keep in a file all the renovations that happened in the past to make the "sku replacement".

To be able to forecast renovation, which have no historic, as regular SKUs,
we copy the historic of a similar SKU and we assign it the  SKU code of the renovated SKU,
so it can mimic its sale historic.

The steps are described below.

.. figure:: ./../_static/plc_workflow_2_spain_dairy.png
    :width: 800
    :align: center


**IBP Export**
==============

To prepare the file export to IBP, we do the following steps:

* We apply the PLC rules
    * We ramp down the forecast of delisted SKUs to zero, between the phase-out start date
      and the phase-out end date.
    * We make the forecast of renovated SKUs start from the phase-in start date
* We remove orders on warehouses closures
* We apply the building blocks by multiplying each forecast to uplift values
  depending of the franchises that are in promotion for each (product, warehouse).

The result is the share of the Total forecast that was generated by the
promotional forecast uplift.

"""
